# custom-mapbox-host

#### 1. Configuring Mapbox API hostname

The KeplerGL component accepts an optional parameter `mapboxApiUrl` to override the default value of `https://api.mapbox.com`.

```js
  <KeplerGl
      id="foo"
      mapboxApiAccessToken={token}
      mapboxApiUrl={"https://api.mapbox.cn"}
      width={width}
      height={height}/>
```

#### 2. Overriding the default MapStyles

The default MapStyles KeplerGL uses might not be accessible to you, in this case you will need to provide MapStyle overrides. During construction of your component:

```js
  this.token = '';
  this.apiHost = "https://api.mapbox.cn";
  this.mapStyles = [
    {
      id: 'dark',
      label: 'Dark Streets 9',
      url: 'mapbox://styles/mapbox/dark-v9',
      icon: `${this.apiHost}/styles/v1/mapbox/dark-v9/static/-122.3391,37.7922,9.19,0,0/400x300?access_token=${this.token}&logo=false&attribution=false`,
      layerGroups: [] // DEFAULT_LAYER_GROUPS
    },
    {
      id: 'light',
      label: 'Light Streets 9',
      url: 'mapbox://styles/mapbox/light-v9',
      icon: `${this.apiHost}/styles/v1/mapbox/light-v9/static/-122.3391,37.7922,9.19,0,0/400x300?access_token=${this.token}&logo=false&attribution=false`,
      layerGroups: [] // DEFAULT_LAYER_GROUPS
    }
  ];
```

and In render:

```js
  <KeplerGl
      id="foo"
      mapboxApiAccessToken={this.token}
      mapboxApiUrl={this.apiHost}
      mapStyles={this.mapStyles}
      width={width}
      height={height}/>
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.kepler.gl/docs/api-reference/advanced-usages/custom-mapbox-host.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
